<template>
  <div id="app">
    <NavBar />
    <router-view
      @product-data="getProduct"
      :products="products"
      @product-to-update="getNewProduct"
      @product-to-delete="getProductToDelete"
    />
  </div>
</template>

<script>
import NavBar from "./components/NavBar.vue";

export default {
  name: "App",
  components: {
    NavBar,
  },
  created() {
    console.log(this.products);
  },
  data() {
    return {
      products: [],
      counter: 0
    };
  },
  methods: {
    getProduct: function(product) {
      this.products.push({
        'id': this.counter++,
        'name': product.name,
        'desc': product.desc,
        'price': product.price
      })
    },
    getNewProduct: function(product) {
      this.updateProduct(product);
    },
    getProductToDelete: function(productToDelete) {
      this.deleteProduct(productToDelete)
    },
    updateProduct: function(updatedProduct) {
      for (let index = 0; index < this.products.length; index++) {
        if (updatedProduct.id === this.products[index].id) {
          this.products[index].name = updatedProduct.name;
          this.products[index].desc = updatedProduct.desc;
          this.products[index].price = updatedProduct.price;
        }
      }
    },
    deleteProduct: function(productToDelete) {
      for (let index = 0; index < this.products.length; index++) {
        if (productToDelete === this.products[index].id) {
          this.products.splice(index, 1)
        }
      }
    }
  },
};
</script>

<style>
#app {
  font-family: Avenir, Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: black
}

#nav {
  padding: 30px;
}

#nav a {
  font-weight: bold;
  color:slategrey
}

#nav a.router-link-exact-active {
  color: aquamarine
}
</style>
